SoTranslate1Dragger(3)

NAME
SoTranslate1Dragger - The SoTranslate1Dragger class provides a mechanism for the end-user to translate along an axis.

SYNOPSIS

#include <Inventor/draggers/SoTranslate1Dragger.h>

Inherits SoDragger.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoNodekitCatalog * getNodekitCatalog (void) const
SoTranslate1Dragger (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static const SoNodekitCatalog * getClassNodekitCatalog (void)
static void initClass (void)

  Public Attributes
SoSFVec3f translation
SoSFFloat minTranslation
SoSFFloat maxTranslation

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoTranslate1Dragger (void)
virtual SbBool setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void setMotionMatrix (const SbMatrix &matrix)
void dragStart (void)
void drag (void)
void dragFinish (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoNodekitCatalog ** getClassNodekitCatalogPtr (void)
static void startCB (void *f, SoDragger *d)
static void motionCB (void *f, SoDragger *d)
static void finishCB (void *f, SoDragger *d)
static void fieldSensorCB (void *f, SoSensor *s)
static void valueChangedCB (void *f, SoDragger *d)

  Protected Attributes
SoSFNode feedback
SoSFNode feedbackActive
SoSFNode feedbackSwitch
SoSFNode translator
SoSFNode translatorActive
SoSFNode translatorSwitch
SoFieldSensor * fieldSensor
SbLineProjector * lineProj

  Additional Inherited Members

Detailed Description

The SoTranslate1Dragger class provides a mechanism for the end-user to translate along an axis. Here's how the dragger looks with its default geometry in the inactive state:

 Screen Shot of Default Dragger

Use this dragger to allow the end-user of your application to translate along the X-axis, i.e. freely along a line. (Use a transformation node in front of the dragger to position it and re-orient it to translate along any line.)

See also
    SoTranslate2Dragger, SoDragPointDragger

Constructor & Destructor Documentation

  SoTranslate1Dragger::SoTranslate1Dragger (void)
Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

CLASS SoTranslate1Dragger
-->'this'
      'callbackList'
      'topSeparator'
         'motionMatrix'
         'geomSeparator'
-->         'translatorSwitch'
-->            'translator'
-->            'translatorActive'
-->         'feedbackSwitch'
-->            'feedback'
-->            'feedbackActive'

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

CLASS SoTranslate1Dragger
PVT   'this',  SoTranslate1Dragger  ---
      'callbackList',  SoNodeKitListPart [ SoCallback, SoEventCallback ]
PVT   'topSeparator',  SoSeparator  ---
PVT   'motionMatrix',  SoMatrixTransform  ---
PVT   'geomSeparator',  SoSeparator  ---
PVT   'translatorSwitch',  SoSwitch  ---
      'translator',  SoSeparator  ---
      'translatorActive',  SoSeparator  ---
PVT   'feedbackSwitch',  SoSwitch  ---
      'feedback',  SoSeparator  ---
      'feedbackActive',  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

  SoTranslate1Dragger::~SoTranslate1Dragger (void) [protected], [virtual]
Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

Member Function Documentation

  SoType SoTranslate1Dragger::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoTranslate1Dragger::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDragger.

  const SoFieldData ** SoTranslate1Dragger::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoTranslate1Dragger::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDragger.

  const SoNodekitCatalog * SoTranslate1Dragger::getClassNodekitCatalog (void) [static]
Returns the nodekit catalog which defines the layout of this class' kit.

  const SoNodekitCatalog * SoTranslate1Dragger::getNodekitCatalog (void) const [virtual]
Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

  const SoNodekitCatalog ** SoTranslate1Dragger::getClassNodekitCatalogPtr (void) [static], [protected]
Returns the pointer to the pointer of the nodekit catalog for this class.

  void SoTranslate1Dragger::initClass (void) [static]
Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

  SbBool SoTranslate1Dragger::setUpConnections (SbBool onoff, SbBool doitalways = FALSE) [protected], [virtual]
Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

  void SoTranslate1Dragger::setMotionMatrix (const SbMatrix & matrix) [protected], [virtual]
Sets a new current motion matrix for the dragger geometry.

Triggers value changed callbacks if matrix is not equal to the previous motion matrix.

Reimplemented from SoDragger.

  void SoTranslate1Dragger::startCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoTranslate1Dragger::motionCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoTranslate1Dragger::finishCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoTranslate1Dragger::fieldSensorCB (void * d, SoSensor * s) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoTranslate1Dragger::valueChangedCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoTranslate1Dragger::dragStart (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

  void SoTranslate1Dragger::drag (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

  void SoTranslate1Dragger::dragFinish (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

Member Data Documentation

  SoSFVec3f SoTranslate1Dragger::translation
Continuously updated to contain the current translation from the dragger's local origo position. Only the first component (the X value) can be changed by the end-user.

The application programmer applying this dragger in his code should connect the relevant node fields in the scene to this field to make it follow the dragger.

  SoSFVec2f SoTranslate1Dragger::minTranslation
Sets the minimum value allowed in the x component of the translation field. This is only active if minTranslation <= maxTranslation.

Default value is 1.0

Since
    Coin 3.0

Sets the minimum value allowed in each component of the translation field. This is only active if minTranslation <= maxTranslation for each component.

Default value is [1.0, 1.0]

Since
    Coin 3.0

  SoSFVec2f SoTranslate1Dragger::maxTranslation
Sets the maximum value allowed in the x component of the translation field. This is only active if minTranslation <= maxTranslation.

Default value is 0.0.

Since
    Coin 3.0

Sets the maximum value allowed in each component of the translation field. This is only active if minTranslation <= maxTranslation for each component.

Default value is [0.0, 0.0]

Since
    Coin 3.0

  SoFieldSensor * SoTranslate1Dragger::fieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SbLineProjector * SoTranslate1Dragger::lineProj [protected]
The SbLineProjector instance used for projecting from 2D mouse cursor positions to 3D points.

Author

Generated automatically by Doxygen for Coin from the source code.